'' =================================================================================================
''
''   File....... 
''   Purpose.... 
''   Author..... John Abshier
''               -- see below for terms of use
''   E-mail..... jabshier@kc.rr.com
''   Started.... 
''   Updated.... 
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' _xinfreq = 6_250_000                                          ' use 6.25MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1 = 31
  TX1 = 30
  SDA = 29
  SCL = 28


  

con

   #1, HOME, GOTOXY, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR       ' PST formmatting control
  #14, GOTOX, GOTOY, CLS


obj

  pst : "fullduplexserial"
 

var
word last, played

pub main 

  pst.start(RX1, TX1, %0000, 115_200)
  repeat until pst.rxCheck <> -1

  pst.str(string(CLS, "Hello, World!", CR, CR))

  repeat   50
    get_random
    
pub get_random | lotto            

  repeat
    lotto := ?cnt >> 1 // 14                                    ' 0 to 13 inclusive
    ifnot (lotto == last)                                       ' if not back-to-back
      ifnot (played & |<lotto)                                  ' and not already played
        played |= |<lotto                                       ' add to play list
        pst.tx(CR)
        pst.Str(String("lotto = "))
        pst.Dec (lotto)
        pst.tx(TAB)
        pst.Str(string("played = "))
        pst.bin(played, 16)
            
        if (played == $3FFF)                                    ' if list is full                                    
          played := 0                                           '  reset it
          pst.tx(CR)
          pst.Str(String("Reset"))
        last := lotto                                           ' save for next cycle
        return lotto                                            ' return file to play

pub pause(ms) | t

'' Delay program ms milliseconds

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)                                              ' delay must be > 0
    waitcnt(t += MS_001)
    

pub high(pin)

'' Makes pin output and high

  outa[pin] := 1
  dira[pin] := 1


pub low(pin)

'' Makes pin output and low

  outa[pin] := 0
  dira[pin] := 1


pub toggle(pin)

'' Toggles pin state

  !outa[pin]
  dira[pin] := 1


pub input(pin)

'' Makes pin input and returns current state

  dira[pin] := 0

  return ina[pin]


pub bit_count(value) | bc

'' Returns # of bits set in value

  bc := 0                                                       ' clear count
  repeat 32                                                     ' test all bits
    bc += (value & %1)                                          ' add bit value to count
    value >>= 1                                                 ' next bit

  return bc


pub bit_pos(value, mode)

'' Returns position of 1st bit set
'' -- mode 0 to scan from lsb, mode 1 to scan from msb 
'' -- -1 = no bits set

  if (value == 0)                                               ' if no bits                                   
    return -1                                                   '  return -1

  else
    if (mode == 0)                                              ' check from LSB
      value ><= 32                                              '  flip for >|
      return (32 - >|value)
    else
      return (>|value - 1)


pub get_nib(target, pos)

'' returns nib value (0..15) of target.nib[pos]

  if ((pos => 0) and (pos =< 3))
    return (target >> (pos << 2)) & %1111
  else
    return 0

    
pub get_quart(target, pos)

'' returns quarternary value (0..3) of target.quart[pos] 

  if ((pos => 0) and (pos =< 7))
    return (target >> (pos << 1)) & %11
  else
    return 0


pub get_bit(target, pos)

'' returns bit value (0..1) of target.pos

  if ((pos => 0) and (pos =< 31))
    return (target >> pos) & 1
  else
    return 0


pub put_bit(target, pos, value)

'' writes value.0 to target.pos

  if (value & 1)
    return target | (1 << pos)
  else
    return target & !(1 << pos)


pub toggle_bit(target, pos)

'' toggles target.pos

  return target ^ (1 << pos)
  
 
dat

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}